// file Assertion.java
// jlouie 1.98
// see Java Developer's Journal 2:12
// extended assert to pass parameter identifying cause of exception
// extended Assertion to implement static attribute to turn off assertion checking
// you should only need to set attribute to false and recompile this file

public class Assertion {
    // change this to false and recompile to turn off assertions
    public static final boolean IS_ASSERTIONS_ON= true;
    // disallow instantiation of this class
    private Assertion() {};
    public static void assert(boolean isValid) throws AssertionException {
        if (IS_ASSERTIONS_ON){
            if (! isValid) {throw new AssertionException();}
        }
        // else do nothing.
    }
    public static void assert(boolean isValid, String message)throws AssertionException {
        if (IS_ASSERTIONS_ON) {
            if(! isValid) {throw new AssertionException(message);}
        }
        // else do nothing.
    }
}